package net.t2code.commandguiv2.Spigot.config.configConverter;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.ConfigValues;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class ConfigConverterV6 {

    public ConfigConverterV6() {
        try {
            convert();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private File configOld;
    private YamlConfiguration yamlConfigurationOld;

    private File defaultUseItem = new File(Main.getPath(), "UseItems/default.yml");
    private YamlConfiguration yamlConfigurationUseItem = YamlConfiguration.loadConfiguration(defaultUseItem);

    private void convert() throws IOException {


        File oldF = new File("plugins/T2C-CommandGUI/config.yml");
        File newF = new File("plugins/T2C-CommandGUI/configV5.yml");
        oldF.renameTo(newF);

        configOld = new File(Main.getPath(), "configV5.yml");
        yamlConfigurationOld = YamlConfiguration.loadConfiguration(configOld);
        set(ConfigValues.debug, "Plugin.Debug");

        set(ConfigValues.updateCheckOnJoin, "Plugin.updateCheck.onJoin");
        set(ConfigValues.updateCheckSeePreReleaseUpdates, "Plugin.updateCheck.seePreReleaseUpdates");
        set(ConfigValues.updateCheckTimeInterval, "Plugin.updateCheck.timeInterval");
        set(ConfigValues.helpAlias, "Plugin.HelpAlias");
        set(ConfigValues.adminSubCommand, "Plugin.AdminSubCommand");
        set(ConfigValues.language, "Plugin.language");
        set(ConfigValues.currency, "Plugin.Currency");
        set(ConfigValues.defaultGUI, "Plugin.DefaultGUI");

        set(ConfigValues.storage, "Storage.Type");
        set(ConfigValues.mysqlIp, "Storage.MySQL.IP");
        set(ConfigValues.mysqlPort, "Storage.MySQL.Port");
        set(ConfigValues.mysqlDatabase, "Storage.MySQL.Database");
        set(ConfigValues.mysqlUser, "Storage.MySQL.User");
        set(ConfigValues.mysqlPassword, "Storage.MySQL.Password");
        set(ConfigValues.mysqlSSL, "Storage.MySQL.SSL");

        set(ConfigValues.useItemEnable, "UseItem.Enable");
        set(ConfigValues.useItemAllowToggle, "UseItem.AllowToggle");
        set(ConfigValues.useItemAllowSetSlot, "UseItem.AllowSetSlot");
        set(ConfigValues.useItemBlockMoveAndDrop, "UseItem.BlockMoveAndDrop");
        set(ConfigValues.useItemOpenGUI, "UseItem.OpenGUI");
        set(ConfigValues.useItemPermission, "UseItem.Permission.NeededToUse");
        set(ConfigValues.useItemKeepAtCommandClear, "UseItem.KeepAtCommandClear");

        set(ConfigValues.useItemInventorySlotFreeSlot, "UseItem.InventorySlot.FreeSlot");
        set(ConfigValues.useItemInventorySlot, "UseItem.InventorySlot.Slot");
        set(ConfigValues.useItemInventorySlotEnforce, "UseItem.InventorySlot.SlotEnforce");
        set(ConfigValues.useItemMaterial, "UseItem.Item.Material");

        set(ConfigValues.useItemPlayerHeadEnable, "UseItem.Item.PlayerHead.Enable");
        set(ConfigValues.useItemBase64Enable, "UseItem.Item.PlayerHead.Base64.Enable");
        set(ConfigValues.useItemBase64value, "UseItem.Item.PlayerHead.Base64.Base64Value");
        set(ConfigValues.useItemPlayerWhoHasOpenedTheGUI, "UseItem.Item.PlayerHead.PlayerWhoHasOpenedTheGUI");
        set(ConfigValues.useItemPlayerName, "UseItem.Item.PlayerHead.PlayerName");
        set(ConfigValues.useItemName, "UseItem.Item.Name");
        set(ConfigValues.useItemLore, "UseItem.Item.Lore");
        set(ConfigValues.useItemGiveOnEveryJoin, "UseItem.Join.GiveOnEveryJoin");
        set(ConfigValues.useItemGiveOnlyOnFirstJoin, "UseItem.Join.GiveOnlyOnFirstJoin");
        set(ConfigValues.cursorToGUIItemOnLogin, "UseItem.Join.Cursor.ToGUIItem.OnLogin.Enable");
        set(ConfigValues.cursorToGUIItemOnlyOnFirstLogin, "UseItem.Join.Cursor.ToGUIItem.Spigot.OnlyOnFirstLogin");
        set(ConfigValues.useItemServerChange, "UseItem.Join.Cursor.ToGUIItem.Bungee.OnServerChange");

        set(ConfigValues.toggleItemOnOrYesBase64, "Toggle.Items.OnOrYes.Item.Base64.Enable");
        set(ConfigValues.toggleItemOnOrYesBase64Value, "Toggle.Items.OnOrYes.Item.Base64.Base64Value");
        set(ConfigValues.toggleItemOnOrYesMaterial, "Toggle.Items.OnOrYes.Item.Material");

        set(ConfigValues.toggleItemOffOrNoBase64, "Toggle.Items.OffOrNo.Item.Base64.Enable");
        set(ConfigValues.toggleItemOffOrNoBase64Value, "Toggle.Items.OffOrNo.Item.Base64.Base64Value");
        set(ConfigValues.toggleItemOffOrNoMaterial, "Toggle.Items.OffOrNo.Item.Material");

        set(ConfigValues.togglePermTrue, "Toggle.Permission.Commands.True");
        set(ConfigValues.togglePermFalse, "Toggle.Permission.Commands.False");

        set(ConfigValues.placeholderTrue, "Placeholder.True");
        set(ConfigValues.placeholderFalse, "Placeholder.False");

        set(ConfigValues.soundEnable, "Sound.Enable");
        set(ConfigValues.soundOpenInventoryEnable, "Sound.OpenInventory.Enable");
        set(ConfigValues.soundOpenInventoryInput, "Sound.OpenInventory.Sound");
        set(ConfigValues.soundClickEnable, "Sound.Click.Enable");
        set(ConfigValues.soundClickInput, "Sound.Click.Sound");
        set(ConfigValues.soundNoMoneyEnable, "Sound.NoMoney.Enable");
        set(ConfigValues.soundNoMoneyInput, "Sound.NoMoney.Sound");

        set(ConfigValues.soundNoInventorySpaceEnable, "Sound.NoInventorySpace.Enable");
        set(ConfigValues.soundNoInventorySpaceInput, "Sound.NoInventorySpace.Sound");
        set(ConfigValues.soundGiveEnable, "Sound.Give.Enable");
        set(ConfigValues.soundGiveInput, "Sound.Give.Sound");
        set(ConfigValues.soundPlayerNotFoundEnable, "Sound.PlayerNotFound.Enable");
        set(ConfigValues.soundPlayerNotFoundInput, "Sound.PlayerNotFound.Sound");

        set(ConfigValues.useItemGameModeChangeEnable, "Advanced.UseItem.GameMode.Change.Enable");
        set(ConfigValues.useItemGameModeChangeDelayInTicks, "Advanced.UseItem.GameMode.Change.DelayInTicks");
        set(ConfigValues.useItemGameModeProtection, "Advanced.UseItem.GameMode.Protection.Enable");
        set(ConfigValues.useItemGameModeRemoveItemWhenItIsDisabled, "Advanced.UseItem.GameMode.Protection.RemoveItemWhenItIsDisabled");
        set(ConfigValues.useItemGameModeMode, "Advanced.UseItem.GameMode.Protection.Mode");

        set(ConfigValues.useItemGameModeList, "Advanced.UseItem.GameMode.Protection.List");

        set(ConfigValues.useItemWorldChangeEnable, "Advanced.UseItem.World.Change.Enable");
        set(ConfigValues.useItemWorldChangeDelayInTicks, "Advanced.UseItem.World.Change.DelayInTicks");
        set(ConfigValues.useItemWorldProtection, "Advanced.UseItem.World.Protection.Enable");
        set(ConfigValues.useItemWorldRemoveItemWhenItIsDisabled, "Advanced.UseItem.World.Protection.RemoveItemWhenItIsDisabled");
        set(ConfigValues.useItemWorldMode, "Advanced.UseItem.World.Protection.Mode");
        set(ConfigValues.useItemWorldList, "Advanced.UseItem.World.Protection.List");

        set(ConfigValues.disableInfoBySneak, "Advanced.UseItem.DisableInfoBySneak");


        set(ConfigValues.useItemItemBlockBlacklist, "Advanced.UseItem.ItemBlockBlacklist");
    }

    private void set(ConfigValues obj, String path) {
        if (!yamlConfigurationOld.contains(path)) return;
        obj.value = yamlConfigurationOld.get(path);
    }
}
