package net.t2code.commandguiv2.Spigot.config.useItems;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.ConfigValues;
import net.t2code.commandguiv2.Spigot.config.configConverter.ConfigConverterV5;
import net.t2code.commandguiv2.Spigot.config.configConverter.ConfigConverterV6;
import net.t2code.commandguiv2.Spigot.enums.EcoEnum;
import net.t2code.commandguiv2.Spigot.enums.FunctionItemEnum;
import net.t2code.commandguiv2.Spigot.enums.FunctionVoteEnum;
import net.t2code.commandguiv2.Spigot.objects.FunctionObject;
import net.t2code.commandguiv2.Spigot.objects.UseItemObject;
import net.t2code.commandguiv2.Util;
import net.t2code.commandguiv2.cache.Cache;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class UseItemSelect {

    public UseItemSelect(){
        create();
        onSelectFunction();
    }

    private void create(){
        File config = new File(Main.getPath(), "/UseItems/default.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        for (UseItemValues value : UseItemValues.values()) {
            T2Cconfig.set(value.path, value.value, yamlConfiguration);
        }

        try {
            yamlConfiguration.save(config);
        } catch (
                IOException e) {
            e.printStackTrace();
        }
    }
    private void onSelectFunction() {
        Cache.useItemHash.clear();
        File f = new File(Main.getPath() + "/UseItems/");
        File[] fileArray = f.listFiles();

        for (File config : fileArray) {
            if (config.getName().equals("useItemDeclaration.yml")) continue;
            String sub = config.getName().substring(config.getName().length() - 4);
            if (sub.equals(".yml")) {
                YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

                String key = config.getName().replace(".yml", "");






                UseItemObject useItem = new UseItemObject(key);
                Cache.useItemHash.put(key, useItem);

                try {
                    yamlConfiguration.save(config);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

}
